//+------------------------------------------------------------------+
//|    :   ,       |
//|,  - .                          Combo_Right.mq5 |
//|                                          Copyright 2012, Integer |
//|                          https://login.mql5.com/ru/users/Integer | 
//|     CCI,   CCI          |
//| - ,  - .       |
//|    .     | 
//|        
//| -  ,      
//|        
//| -  .     
//|  .     |
//|  .   pass,   
//|   1  4-.   1   
//|,     . 
//|  pass=1   : tp1, sl1, 
//|CCIPeriod, CCIPrice.   pass=2   , |
//|   : x12, x22, x32, x42, tp2, sl2, p2. |
//|,  pass=3   ,   | 
//|: x13, x23, x33, x43, tp3, sl3, p3.   ,    |
//| pass=4,   ,    
//|: x14, x24, x34, x44, p4.                                        |       
//|     pass=4.                                 | 
//+--------------------------------------------------------------------------+
#property copyright "Integer"
#property link "https://login.mql5.com/ru/users/Integer"
#property description ""
#property version   "1.00"

#property description "   MQ4,  Reshetov (http://www.mql4.com/ru/users/Reshetov),    - http://codebase.mql4.com/ru/2719"

#include <Trade/Trade.mqh>
#include <Trade/SymbolInfo.mqh>
#include <Trade/PositionInfo.mqh>

CTrade Trade;
CSymbolInfo Sym;
CPositionInfo Pos;
   
//--- input parameters

input double                           tp1               =  2600;              /*tp1*/           //        
input double                           sl1               =  800;              /*sl1*/           //        
input int                              CCIPeriod         =  14;	            /*CCIPeriod*/     //  CCI
input ENUM_APPLIED_PRICE               CCIPrice          =  PRICE_OPEN;	      /*CCIPrice*/      //  CCI

input int                              x12               =  5;              /*x12*/           //   
input int                              x22               =  8;
input int                              x32               =  13;
input int                              x42               =  21;
input double                           tp2               =  8.0;              /*tp2*/           //        
input double                           sl2               =  55;              /*sl2*/           //        
input int                              p2                =  20;               /*p2*/            //      

input int                              x13               =  8;              /*x13*/           //   
input int                              x23               =  13;
input int                              x33               =  21;
input int                              x43               =  34;
input double                           tp3               =  55;              /*tp3*/           //        
input double                           sl3               =  55;              /*sl3*/           //        
input int                              p3                =  20;               /*p3*/            //      

input int                              x14               =  31;              /*x14*/           //   
input int                              x24               =  17;
input int                              x34               =  60;
input int                              x44               =  36;
input int                              p4                =  20;               /*p4*/            //      

input int                              pass              =  4;                /*pass*/          //   : 1 -  , 1 -  , 2 -  , 4 -  ,  .
input double                           lots              =  1.2;
input int                              Shift             =  1;                /*Shift*/         //       : 0 -  , 1 -   


double w11;
double w12;
double w13;
double w14;

double w21;
double w22;
double w23;
double w24;

double w31;
double w32;
double w33;
double w34;

int sh11;
int sh12;
int sh13;
int sh14;
int sh15;

int sh21;
int sh22;
int sh23;
int sh24;
int sh25;

int sh31;
int sh32;
int sh33;
int sh34;
int sh35;

double output1;
double output2;
double output3;
//---  
input double  MM=0.015;       // Money Management
input int      StopLoss=200;      // Stop Loss
input int      TakeProfit=80;   // Take Profit
input int      ADX_Period=14;     //  ADX
input int      MA_Period=13;      //  Moving Average
input int      EA_Magic=12345;   // Magic Number 
input double   Adx_Min=22.0;     //   ADX
input double   Lot=0.5;          //    
//---  
int adxHandle; //   ADX
int maHandle;  //   Moving Average
double plsDI[],minDI[],adxVal[]; //       +DI, -DI  ADX   
double maVal[]; //       Moving Average   
double p_close; //     close 
int STP,TKP;    //     Stop Loss  Take Profit

int CCIHandle=INVALID_HANDLE;


int          prevtime = 0;
double       sl = 35;
double       tp = 15;

int Handle=INVALID_HANDLE;

datetime ctm[1];
datetime LastTime;
double lot,slv,msl,tpv,mtp;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){

   w11=x12-9;
   w12=x22-22;
   w13=x32-21;
   w14=x42-22;
      
   w21=x13-80;
   w22=x23-143;
   w23=x33-344;
   w24=x43-70;
      
   w31=x14-31;
   w32=x24-17;
   w33=x34-60;
   w34=x44-36;
   
   sh11=Shift;
   sh12=Shift+p2;
   sh13=Shift+p2*2;
   sh14=Shift+p2*3;
   sh15=Shift+p2*4;
   
   sh21=Shift;
   sh22=Shift+p3;
   sh23=Shift+p3*2;
   sh24=Shift+p3*3;
   sh25=Shift+p3*4;      
   
   sh31=Shift;
   sh32=Shift+p4;
   sh33=Shift+p4*2;
   sh34=Shift+p4*3;
   sh35=Shift+p4*4;     

   //  ...
   
   CCIHandle=iCCI(_Symbol,PERIOD_CURRENT,CCIPeriod,CCIPrice);

   if(CCIHandle==INVALID_HANDLE){
      Alert("  ,  ");
      return(-1);
   }   
   
   if(!Sym.Name(_Symbol)){
      Alert("  CSymbolInfo,  ");    
      return(-1);
   }

   Print("  ");
   //---    ADX
   adxHandle=iADX(NULL,0,ADX_Period);
//---    Moving Average
   maHandle=iMA(_Symbol,_Period,MA_Period,0,MODE_EMA,PRICE_CLOSE);
//---  ,      Invalid Handle
   if(adxHandle<0 || maHandle<0)
     {
      Alert("    -  : ",GetLastError(),"!!");
      return(-1);
     }

//---    ,  3-  5-  ,
//---   10  SL  TP
   STP = StopLoss;
   TKP = TakeProfit;
   if(_Digits==5 || _Digits==3)
     {
      STP = STP*10;
      TKP = TKP*10;
     }

   return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   if(CCIHandle!=INVALID_HANDLE)IndicatorRelease(CCIHandle);
   //---   
   IndicatorRelease(adxHandle);
   IndicatorRelease(maHandle);
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){
//---      
   if(Bars(_Symbol,_Period)<60) //       60?
     {
      Alert("   60 !!");
      return;
     }
//---        static- Old_Time.
//---     OnTick         .
//---    ,  ,     .

   static datetime Old_Time;
   datetime New_Time[1];
   bool IsNewBar=false;

//---       New_Time[0]
   int copied=CopyTime(_Symbol,_Period,0,1,New_Time);
   if(copied>0) // ok,  
     {
      if(Old_Time!=New_Time[0]) //     
        {
         IsNewBar=true;   //  
         if(MQL5InfoInteger(MQL5_DEBUGGING)) Print(" ",New_Time[0]," ",Old_Time);
         Old_Time=New_Time[0];   //   
        }
     }
   else
     {
      Alert("  ,   =",GetLastError());
      ResetLastError();
      return;
     }

//---            
   if(IsNewBar==false)
     {
      return;
     }

//---          
   int Mybars=Bars(_Symbol,_Period);
   if(Mybars<60) //      60
     {
      Alert("   60 ,    !!");
      return;
     }

//-------------------------------------------------------------------+     
   if(CopyTime(_Symbol,PERIOD_CURRENT,0,1,ctm)==-1){
      return;
   }
   if(Shift==0 || ctm[0]!=LastTime){
      
      sl=sl1;
      tp=tp1;      
      
      // 
      double Signal;
      if(!Supervisor(Signal)){
         return;
      }
 
      // 
      if(!Pos.Select(_Symbol)){
            if(Signal>0){ 
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveBuySL(sl);
               tpv=SolveBuyTP(tp);
                  if(CheckBuySL(slv) && CheckBuyTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     if(!Trade.Buy(lot,_Symbol,0,slv,tpv,"")){
                        return;
                     }
                  }
                  else{
                     Print(" Buy  ,    ");
                  }         
            }
            // 
            if(Signal<0){
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveSellSL(sl);
               tpv=SolveSellTP(tp);
                  if(CheckSellSL(slv) && CheckSellTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     if(!Trade.Sell(lot,_Symbol,0,slv,tpv,"")){
                        return;
                     }
                  }
                  else{
                     Print(" Sell  ,    ");
                  }          
            }
      }            
      LastTime=ctm[0];
   }
}

bool Supervisor(double & Signal) {
   double BasicSig=0;
   if(!basicTradingSystem(BasicSig))return(false);
   Signal=0;
   if(pass==4){
      if(!Perceptron(output1,sh11,sh12,sh13,sh14,sh15,w11,w12,w13,w14) ||
         !Perceptron(output2,sh21,sh22,sh23,sh24,sh25,w21,w22,w23,w24) ||
         !Perceptron(output3,sh31,sh32,sh33,sh34,sh35,w31,w32,w33,w34)   
      )return(false);         
      if(output3>0){
         if(output2>0){
            sl=sl3;
            tp=tp3;
            Signal=1;
            return(true);
         }
       }
       else{
         if(output1<0){
            sl=sl2;
            tp=tp2;
            Signal=-1;
            return(true);
         }
      }
      Signal=BasicSig;
      return(true);
   }
   if(pass==3) {
      if(!Perceptron(output2,sh21,sh22,sh23,sh24,sh25,w21,w22,w23,w24))return(false);
      if(output2>0){
         sl=sl3;
         tp=tp3;
         Signal=1;
         return(true);
       } 
       else {
         Signal=BasicSig;
         return(true);
       }
   }
   if(pass==2){
      if(!Perceptron(output1,sh11,sh12,sh13,sh14,sh15,w11,w12,w13,w14))return(false);
      if(output1<0) {
         sl=sl2;
         tp=tp2;
         Signal=-1;
         return(true);
       } 
       else{
         Signal=BasicSig;
         return(true);
       }
   }   
   Signal=BasicSig;
   return(true);
}
   
double Perceptron(double & output,int sh1,int sh2,int sh3,int sh4,int sh5,double w1,double w2,double w3,double w4){
   double Csh1[1],Osh2[1],Osh3[1],Osh4[1],Osh5[1];
   if(CopyClose(_Symbol,PERIOD_CURRENT,sh1,1,Csh1)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh2,1,Osh2)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh3,1,Osh3)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh4,1,Osh4)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,sh5,1,Osh5)==-1
   )return(false);
   double a1=Csh1[0]-Osh2[0];
   double a2=Osh2[0]-Osh3[0];
   double a3=Osh3[0]-Osh4[0];
   double a4=Osh4[0]-Osh5[0];
   output=w1*a1+w2*a2+w3*a3+w4*a4;
   return(true);
}

bool basicTradingSystem(double & aSig){
   aSig=0;
   double cci0[1];
   if(CopyBuffer(CCIHandle,0,Shift,1,cci0)==-1)return(false);
   aSig=cci0[0];
   return(true);
}

//+------------------------------------------------------------------+
//|      ,                    |
//+------------------------------------------------------------------+
bool Indicators(){

   return(true);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenBuy(){

   return(false);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenSell(){

   return(false);
}

//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
bool SignalCloseBuy(){

   return (false);
}

//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
bool SignalCloseSell(){

   return (false);
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
double SolveBuySL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()-Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      buy                             |
//+------------------------------------------------------------------+
double SolveBuyTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|      sell                               |
//+------------------------------------------------------------------+
double SolveSellSL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()+Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      sell                             |
//+------------------------------------------------------------------+
double SolveSellTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|       buy                  |
//+------------------------------------------------------------------+
double BuyMSL(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       buy                |
//+------------------------------------------------------------------+
double BuyMTP(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell                 |
//+------------------------------------------------------------------+
double SellMSL(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell               |
//+------------------------------------------------------------------+
double SellMTP(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|      buy                                 |
//+------------------------------------------------------------------+
bool CheckBuySL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice<BuyMSL());
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
bool CheckBuyTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice>BuyMTP());
}

//+------------------------------------------------------------------+
//|      sell                                 |
//+------------------------------------------------------------------+
bool CheckSellSL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice>SellMSL());
}

//+------------------------------------------------------------------+
//|      sell                              |
//+------------------------------------------------------------------+
bool CheckSellTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice<SellMTP());
}

//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool SolveLots(double & aLots){
   aLots=lots;         
   return(true);
}
